



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>tomcat 性能调优</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">tomcat 性能调优</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-18 22:21:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1. 内存</p>
<p>windows在bin/catalina.bat的注释下第一行加入</p>
<p>set JAVA_OPTS=-Xms2048m -Xmx2048m -Xss128K -XX:PermSize=64m -XX:MaxPermSize=256m</p>
<p>linux在bin/catalina.sh的注释下第一行加入</p>
<p>JAVA_OPTS="-Xms2048m -Xmx2048m -Xss128K -XX:PermSize=64m -XX:MaxPermSize=256m"</p>
<p>这些参数是否生效，可以通过命令jmap -heap 进程ID查看。</p>
<p>最大堆内存和最小堆内存最好设置为一样的。堆内存一般设置为可用内存的80%左右，后面的几个参数根据堆内存进行调整。</p>
<p>2. IO优化</p>
<p>tomcat一共有三种IO策略，bio（默认，兼顾旧jdk，性能差），nio，apr</p>
<p>这里修改为nio：</p>
<p>把 &nbsp;&nbsp;&lt;Connector connectionTimeout="20000" port="8080" protocol="HTTP/1.1" redirectPort="8443"/&gt;</p>
<p>改为&lt;Connector connectionTimeout="20000" port="8080" protocol="org.apache.coyote.http11.Http11NioProtocol" redirectPort="8443"/&gt;</p>
<p>apr是使用了系统的异步io，需要安装软件，然后在tomcat中配置，我没有使用这种方式。</p>
<p>3. 线程池</p>
<p>在conf/server.xml中打开Executer，并修改参数如下：</p>
<p>&lt;Executor name="tomcatThreadPool" namePrefix="catalina-exec-" maxThreads="500" minSpareThreads="20" maxIdleTime="60000" /&gt;</p>
<p>在Connector中使用：</p>
<p>&lt;Connector&nbsp;executor="tomcatThreadPool" connectionTimeout="20000" port="8080" protocol="org.apache.coyote.http11.Http11NioProtocol" redirectPort="8443"/&gt;</p>
<p>4. 压缩</p>
<p>在Connector中添加compression="on" compressionMinSize="2048" compressableMimeType="text/html,text/xml,text/javascript,text/css,text/plain"</p>
<p>5. 禁用DNS</p>
<p>在Connector中添加enableLookups="false"</p>
<p>最终Connector如下</p>
<div>
<pre class="prettyprint linenums">&lt;Connector executor="tomcatThreadPool" port="8080" protocol="org.apache.coyote.http11.Http11NioProtocol" maxHttpHeaderSize="8192" maxThreads="1000" minSpareThreads="100" maxSpareThreads="1000" minProcessors="100" maxProcessors="1000" enableLookups="false" compression="on" compressionMinSize="2048" compressableMimeType="text/html,text/xml,text/javascript,text/css,text/plain" connectionTimeout="20000" URIEncoding="utf-8" acceptCount="1000" redirectPort="8443" disableUploadTimeout="true"/&gt;</pre>
</div>
<p>如此修改后，我的tomcat吞吐量从380/s达到了3800/s，完全扩大了10倍。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g621lq.html">3分钟wamp中php安装 pear  然而并没有用  并没能借此安装phpunit 不得不借用了其他的方式安装phpunit</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r21jeq.html">利用Delphi的File Of Type创建并管理属于你自己的数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkvyd8.html">排序算法总结（一）插入排序【Insertion Sort】</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xd3mz9.html">HW7&period;15</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w2n3wq.html">【Linux高频命令专题&lpar;5&rpar;】rmdir</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwr719.html">Palindromic Number &lpar;还是大数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdex44j9.html">html5在手机端关于 map area中的自适应</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1xyoq.html">vijosP1071 新年趣事之打牌</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0nk09.html">《Linear Algebra and Its Applications》-chaper6-正交性和最小二乘法-基本概念与定理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jdk7l8.html">BZOJ 100题留念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp0xrvq.html">&lbrack;HDU 1973&rsqb;--Prime Path&lpar;BFS&comma;素数表&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyvxk8.html">java开发笔记&mdash;&mdash;表映射实体类代码示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxp7n8.html">测试驱动开发TDD&lpar;test drive development&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jz0gq.html">Series</a>
		</li>
						<li><a href="https://www.batexi.com/a/950o5408.html">idea如何快速查看接口的实现类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eydlpx9.html">【转】Java中的static关键字解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdw2pd9.html">常见的JavaWeb安全问题及修复</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gd256q.html">HAProxy &plus; Keepalived &plus; Flume 构建高性能高可用分布式日志系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gygevq.html">Ubuntu16&period;04中搭建TFTP 和 NFS 服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wkg3rq.html">《Linux课本》读书笔记 第四章</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8ko0ry5q.html">预定义的类型&OpenCurlyDoubleQuote;System&period;Object&rdquo;未定义或未导入</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppnvr49.html">kvm虚拟化一： 图形化的管理方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kd67xq.html">由于未能创建 Microsoft Visual C&num; 2008 编译器，因此未能打开项目 &amp;quot&semi;&period;&period;&period;&amp;quot&semi;的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1e7269.html">&lbrack;hdu5503&rsqb;EarthCup&lbrack;霍尔定理&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjmvxr8.html">stl源码剖析 详细学习笔记 算法&lpar;3&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pg525q.html">阿里云CentOS 7&period;4 64位，jdk1&period;6、mysql5&period;7、tomcat6部署步骤（个人记录）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjm6008.html">&lbrack;ERROR&rsqb; Failed to execute goal net&period;alchim31&period;maven&colon;scala-maven-plugin&colon;3&period;2&period;2&colon;compile &lpar;scala-compile-first&rpar; on project spark-tags&lowbar;2&period;11&colon; Execution scala-compile-first of goal net&period;alchim31&period;maven&colon;scala-mave</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kd1dxq.html">（功能篇）回顾Bug管理系统Mantis优化改造经历</a>
			</li>
						<li><a href="https://www.batexi.com/a/953r12v8.html">Istio 流量治理功能原理与实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/963jwyj9.html">谷歌算法研究员：我为什么钟爱PyTorch？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
